unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, MiTeC.IBH.Lib.Common, MiTeC.IBH.Component.Browsers;

type
  TForm2 = class(TForm)
    List: TListView;
    Button2: TButton;
    sd: TSaveDialog;
    Button3: TButton;
    Memo: TMemo;
    Edit1: TEdit;
    Button1: TButton;
    eBrowser: TEdit;
    Button4: TButton;
    od: TOpenDialog;
    procedure ListSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure cmRefresh(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    FIH: TIBH_Browsers;
  public
    procedure DisplayResults;
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

procedure TForm2.DisplayResults;
var
  i: Integer;
begin
  Screen.Cursor:=crHourglass;
  try
    List.Items.Clear;
    for i:=FIH.RecordCount-1 downto 0 do
      with List.Items.Add do begin
        Caption:=sInternetBrowser[FIH.Records[i].Browser];
        SubItems.Add(IntToStr(FIH.Records[i].VisitCount));
        SubItems.Add(DatetimeToStr(FIH.Records[i].LastVisited));
        SubItems.Add(FIH.Records[i].URL);
        SubItems.Add(FIH.Records[i].Title);
      end;
    Caption:=Format('Internet Browsers History - %d records',[FIH.RecordCount]);
  finally
    Screen.Cursor:=crDefault;
  end;
end;

procedure TForm2.cmRefresh(Sender: TObject);
begin
  Screen.Cursor:=crHourglass;
  try
    FIH.RefreshData;
    DisplayResults;
  finally
    Screen.Cursor:=crDefault;
  end;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm2.Button3Click(Sender: TObject);
var
  wh: Boolean;
begin
  wh:=True;
  if sd.Execute then
    FIH.AppendToStorage(sd.FileName,wh);
end;

procedure TForm2.Button4Click(Sender: TObject);
var
  wh: Boolean;
begin
  if not od.Execute then
    Exit;
  FIH.LoadFromStorage(od.Filename,wh);
  DisplayResults;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  FIH:=TIBH_Browsers.Create(Self);
  FIH.SQLITEDLL:='..\..\SQLITE\sqlite3.dll';
  //cmRefresh(nil);
end;

procedure TForm2.ListSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  eBrowser.Text:=sInternetBrowser[FIH.Records[FIH.RecordCount-1-Item.Index].Browser];
  Edit1.Text:=FIH.Records[FIH.RecordCount-1-Item.Index].Title;
  Memo.Lines.Text:=FIH.Records[FIH.RecordCount-1-Item.Index].URL;
end;

end.
