unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, MiTeC.IBH.Component.Firefox;

type
  TForm2 = class(TForm)
    List: TListView;
    bClose: TButton;
    bSave: TButton;
    sd: TSaveDialog;
    mFiles: TMemo;
    eURL: TEdit;
    Memo: TMemo;
    eBrowser: TEdit;
    procedure ListSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure bSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bCloseClick(Sender: TObject);
  private
    Browser: TIBH_Firefox;
  public
    procedure DisplayResults;
  end;

var
  Form2: TForm2;

implementation

uses MiTeC.IBH.Lib.Common, MiTeC_CommonDefs, MiTeC_Routines;

{$R *.dfm}

procedure TForm2.DisplayResults;
var
  i: Integer;
  s: string;
  vi: TVersionInfo;
begin
  Screen.Cursor:=crHourglass;
  try
    s:=Browser.BrowserEXE;
    if FileExists(s) then begin
      GetFileVerInfo(s,vi);
      eBrowser.Text:=Format('%s %s',[vi.ProductName,vi.FileVersion]);
    end else
      eBrowser.Text:='Browser is not installed';
    mFiles.Clear;
    mFiles.Lines.AddStrings(Browser.Files);
    List.Items.Clear;
    for i:=0 to Browser.RecordCount-1 do
      with List.Items.Add do begin
        Caption:=Browser.Records[i]._ID;
        SubItems.Add(IntToStr(Browser.Records[i].VisitCount));
        SubItems.Add(DatetimeToStr(Browser.Records[i].LastVisited));
        SubItems.Add(Browser.Records[i].URL);
        SubItems.Add(Browser.Records[i].Title);
      end;
    Caption:=Format('%s History - %d records',[sInternetBrowser[Browser.BrowserID],Browser.RecordCount]);
  finally
    Screen.Cursor:=crDefault;
  end;
end;

procedure TForm2.bCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TForm2.bSaveClick(Sender: TObject);
var
  wh: Boolean;
begin
  wh:=True;
  if sd.Execute then
    Browser.AppendToStorage(sd.FileName,wh);
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  Browser:=TIBH_Firefox.Create(Self);
  Browser.SQLITEDLL:='..\..\SQLITE\sqlite3.dll';
  Browser.ScanFiles;
  Browser.RefreshData;
  DisplayResults;
end;

procedure TForm2.ListSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  eURL.Text:=Browser.Records[Item.Index].Title;
  Memo.Lines.Text:=Browser.Records[Item.Index].URL;
end;

end.
