unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls,
  MiTeC.IBH.Lib.IndexDAT, MiTeC.IBH.Lib.URLHistory, MiTeC.IBH.Lib.WebCache, MiTeC.IBH.Lib.Common;

type
  TForm3 = class(TForm)
    Memo: TMemo;
    Button2: TButton;
    Button1: TButton;
    sd: TSaveDialog;
    Button3: TButton;
    pc: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    List1: TListView;
    List2: TListView;
    TabSheet3: TTabSheet;
    List3: TListView;
    bLoad: TButton;
    od: TOpenDialog;
    Panel1: TPanel;
    eBrowser: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure cmRefresh(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure pcChange(Sender: TObject);
    procedure bLoadClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Button3Click(Sender: TObject);
  private
    IE1: TIBH_IE_IndexDAT;
    IE2: TIBH_IE_URLHist;
    IE3: TIBH_WebCache;
  public
    procedure DisplayData;
  end;

var
  Form3: TForm3;

implementation

uses DateUtils, MiTeC_CommonDefs, MiTeC_Routines;

{$R *.dfm}

procedure TForm3.cmRefresh(Sender: TObject);
begin
  Screen.Cursor:=crHourglass;
  try
    memo.Lines.Clear;
    IE1.ScanFiles;
    IE1.RefreshData;
    IE2.RefreshData;
    IE3.ScanFiles;
    IE3.RefreshData;
    DisplayData;
  finally
    Screen.Cursor:=crDefault;
  end;
end;

procedure TForm3.DisplayData;
var
  i: Integer;
  s: string;
  vi: TVersionInfo;
begin
  s:=IE2.BrowserEXE;
  if FileExists(s) then begin
    GetFileVerInfo(s,vi);
    eBrowser.Text:=Format('%s %s',[vi.ProductName,vi.FileVersion]);
  end else
    eBrowser.Text:='Browser is not installed';
  List1.Items.Clear;
  for i:=IE1.RecordCount-1 downto 0 do
    with List1.Items.Add do begin
      Caption:=IE1.Records[i].Title;
      SubItems.Add(IE1.Records[i].URL);
      SubItems.Add(DatetimeToStr(IE1.Records[i].LastVisited));
      SubItems.Add(IntToStr(IE1.Records[i].VisitCount));
    end;
  TabSheet1.Caption:=Format('Index.dat - %d records',[IE1.RecordCount]);

  List2.Items.Clear;
  for i:=IE2.RecordCount-1 downto 0 do
    with List2.Items.Add do begin
      Caption:=IE2.Records[i].Title;
      SubItems.Add(IE2.Records[i].URL);
      SubItems.Add(DatetimeToStr(IE2.Records[i].LastVisited));
      SubItems.Add(IntToStr(IE2.Records[i].VisitCount));
    end;
  TabSheet2.Caption:=Format('API - %d records',[IE2.RecordCount]);

  List3.Items.Clear;
  for i:=IE3.RecordCount-1 downto 0 do
    with List3.Items.Add do begin
      Caption:=IE3.Records[i].Title;
      SubItems.Add(IE3.Records[i].URL);
      SubItems.Add(DatetimeToStr(IE3.Records[i].LastVisited));
      SubItems.Add(IntToStr(IE3.Records[i].VisitCount));
    end;
  TabSheet3.Caption:=Format('WebCache - %d records',[IE3.RecordCount]);
end;

procedure TForm3.bLoadClick(Sender: TObject);
begin
  if not od.Execute then
    Exit;
  case pc.ActivePageIndex of
    0: IE1.LoadFromFile(od.FileName);
    2: IE3.LoadFromFile(od.FileName);
  end;
  DisplayData;
end;

procedure TForm3.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm3.Button3Click(Sender: TObject);
var
  wh: Boolean;
begin
  wh:=True;
  if sd.Execute then
    case pc.ActivePageIndex of
      0: IE1.AppendToStorage(sd.FileName,wh);
      1: IE2.AppendToStorage(sd.FileName,wh);
      2: IE3.AppendToStorage(sd.FileName,wh);
    end;
end;

procedure TForm3.pcChange(Sender: TObject);
begin
  case pc.ActivePageIndex of
    0: od.Filter:='Index.DAT files|index.dat';
    2: od.Filter:='WebCache files|WebCache*.dat';
  end;
  bLoad.Enabled:=pc.ActivePageIndex<>1;
end;

procedure TForm3.FormCreate(Sender: TObject);
begin
  pc.ActivePageIndex:=0;
  IE1:=TIBH_IE_IndexDAT.Create(Self);
  IE2:=TIBH_IE_URLHist.Create(Self);
  IE3:=TIBH_WebCache.Create(Self);
  cmRefresh(nil);
end;

procedure TForm3.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Shift=[ssCtrl]) and (key=vk_F12) then
    Memo.Visible:=not Memo.Visible;
end;

end.
